package com.jdc.jdcproject.controller;

import com.jdc.jdcproject.entity.DicekePrecipitation;
import com.jdc.jdcproject.entity.Equipment;
import com.jdc.jdcproject.entity.FangpaishuiWatertreatmentrecord;
import com.jdc.jdcproject.entity.VO.FangpaishuiWatertreatmentrecordVo;
import com.jdc.jdcproject.service.FangpaishuiWatertreatmentrecordService;
import com.jdc.jdcproject.utils.LastDayOfMonth;
import com.jdc.jdcproject.utils.Result;
import io.swagger.v3.oas.annotations.Operation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.time.LocalDate;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@RestController
@RequestMapping("/fangpaishuiWatertreatmentrecord")
public class FangpaishuiWatertreatmentrecordController {

    @Autowired
    private FangpaishuiWatertreatmentrecordService fangpaishuiWatertreatmentrecordService;

    @Operation(summary = "根据月查询处理水量和拉泥车数")
    @GetMapping("findWatertreatmentrecordByMonth/{dateTime}")
    public Result findWatertreatmentrecordByMonth(@PathVariable String dateTime) throws ParseException {
       String[] s = dateTime.split("-");
      int year = Integer.parseInt(s[0]);
        int month = Integer.parseInt(s[1]);
        LastDayOfMonth  lastDayOfMonth = new LastDayOfMonth();
        String upDay =  lastDayOfMonth.getLastDayOfMonth(year, month-1);
      String lastDay =  lastDayOfMonth.getLastDayOfMonth(year, month);
         upDay =  lastDayOfMonth.dateCalculations(upDay,5);
        lastDay =  lastDayOfMonth.dateCalculations(lastDay,6);


        List<FangpaishuiWatertreatmentrecord> fangpaishuiWatertreatmentrecords =fangpaishuiWatertreatmentrecordService.findByDate(upDay,lastDay);
        int waterVolume = 0;
        int TruckCount = 0;
        for (int i = 0; i < fangpaishuiWatertreatmentrecords.size(); i++) {
            TruckCount =   fangpaishuiWatertreatmentrecords.get(i).getTruckCount()+TruckCount;
            waterVolume =   fangpaishuiWatertreatmentrecords.get(i).getWaterVolume()+waterVolume;
        }
        FangpaishuiWatertreatmentrecordVo fangpaishuiWatertreatmentrecordVo = new FangpaishuiWatertreatmentrecordVo();
        fangpaishuiWatertreatmentrecordVo.setWaterVolume(waterVolume);
        fangpaishuiWatertreatmentrecordVo.setTruckCount(TruckCount);
        fangpaishuiWatertreatmentrecordVo.setMonthRange(upDay+"到"+lastDay);

        return Result.successResult().data("fangpaishuiWatertreatmentrecordVo",fangpaishuiWatertreatmentrecordVo);
    }

    @Operation(summary = "根据时间段查询处理水量和拉泥车数详细数据")
    @GetMapping("findWatertreatmentrecordDetailByMonth/{dateTime}")
    public Result findWatertreatmentrecordDetailByMonth(@PathVariable String dateTime) throws ParseException {
        String[] s = dateTime.split("到");
        List<FangpaishuiWatertreatmentrecord> fangpaishuiWatertreatmentrecords = new ArrayList<>();
        if (s.length!=0&&!s[0].isEmpty()&&!s[1].isEmpty()) {
             fangpaishuiWatertreatmentrecords = fangpaishuiWatertreatmentrecordService.findByDate(s[0], s[1]);
        }

        return Result.successResult().data("fangpaishuiWatertreatmentrecords",fangpaishuiWatertreatmentrecords);
    }

    @Operation(summary = "修改处理水量和拉泥车信息")
    @PostMapping("updateWatertreatmentrecord")
    public Result updateEquipment(@RequestBody FangpaishuiWatertreatmentrecord fangpaishuiWatertreatmentrecord) {
        boolean updateflag = fangpaishuiWatertreatmentrecordService.updateById(fangpaishuiWatertreatmentrecord);
        if (updateflag) {
            return Result.successResult();
        } else {
            return Result.errorResult();
        }
    }

    @Operation(summary = "删除处理水量和拉泥车信息")
    @DeleteMapping("deleteWatertreatmentrecord/{id}")
    public Result deleteEquipment(@PathVariable String id) {
        boolean updateflag = fangpaishuiWatertreatmentrecordService.removeById(id);
        if (updateflag) {
            return Result.successResult();
        } else {
            return Result.errorResult();
        }
    }

    @Operation(summary = "新增处理水量和拉泥车信息")
    @PostMapping("addWatertreatmentrecord")
    public Result addEquipment(@RequestBody FangpaishuiWatertreatmentrecord fangpaishuiWatertreatmentrecord) {
        System.out.println(fangpaishuiWatertreatmentrecord);
        boolean updateflag = fangpaishuiWatertreatmentrecordService.save(fangpaishuiWatertreatmentrecord);
        if (updateflag) {
            return Result.successResult();
        } else {
            return Result.errorResult();
        }
    }

}
