package com.jdc.jdcproject.entity;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import java.time.LocalDate;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;

/**
 * <p>
 * 采矿记录表;
 * </p>
 *
 * @author haoyanlu
 * @since 2025-04-26
 */
@TableName("diceke_miningrecord")
@Schema(name = "DicekeMiningrecord", description = "采矿记录表;")
@Data
public class DicekeMiningrecord implements Serializable {

    private static final long serialVersionUID = 1L;

    @Schema(description = "主键")
    @TableId("RecordID")
    private String recordID;

    @Schema(description = "外键关联平盘表")
    private String plateID;

    @Schema(description = "外键关联铲号表")
    private String shovelID;

    @Schema(description = "月份")
    private LocalDate month;

    @Schema(description = "采矿量/出矿量/实采总量（单位：吨）")
    private Double totalMiningTon;

    @Schema(description = "金属量（仅铝品位报表需要）")
    private Double metalTon;

    @Schema(description = "块段采矿品位（%）")
    private Double miningGrade;

    @Schema(description = "块段氧化率（%）")
    private Double oxidationRate;

    @Schema(description = "全月平均品位（%）")
    private Double avgGrade;

    @Schema(description = "选矿平均品位（%）")
    private Double dressingGrade;

    @Schema(description = "全月平均氧化率（%）")
    private Double avgOxidationRate;

    @Schema(description = "备注")
    private String beizhu;

    @Override
    public String toString() {
        return "DicekeMiningrecord{" +
        "recordID = " + recordID +
        ", plateID = " + plateID +
        ", shovelID = " + shovelID +
        ", month = " + month +
        ", totalMiningTon = " + totalMiningTon +
        ", metalTon = " + metalTon +
        ", miningGrade = " + miningGrade +
        ", oxidationRate = " + oxidationRate +
        ", avgGrade = " + avgGrade +
        ", dressingGrade = " + dressingGrade +
        ", avgOxidationRate = " + avgOxidationRate +
        "}";
    }
}
